Attribute VB_Name = "Funzioni_LPT"
'----------------------------RICHIAMO ALLA LIBRERIA PER LA GESTIONE DELLA PORTA LPT----------------------------
Public Declare Function Inp Lib "inpout32.dll" Alias "Inp32" (ByVal PortAddress As Integer) As Integer
Public Declare Sub Out Lib "inpout32.dll" Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Integer)

'--------------------------COSTANTI PER GLI INDIRIZZI DELLA PORTA LPT1--------------------------------
Public Const IndirizzoData As String = "&H378" 'REGISTRO DATA: sola scrittura (8 bit)
'Public Const IndirizzoStatus As String = "&H379" 'REGISTRO STATUS: sola lettura (ultimi 5 bit)
'Public Const IndirizzoControl As String = "&H37a" 'REGISTRO CONTROL: lettura + scrittura (primi 4 bit)

Public StatoCubo(1 To 8, 1 To 64) As Integer 'variabile che contiene lo stato attuale di TUTTO il cubo

Public Function ScriviCubo(NumeroCicli As Integer) 'scrive sul cubo lo stato memorizzato nella matrice StatoCubo
    Dim ByteLpt As Byte
    Dim ContaLivelli As Integer
    Dim ContaLed As Integer
    Dim ContaCicli As Integer
    
    For ContaCicli = 1 To NumeroCicli
            
        For ContaLivelli = 1 To 8
    
            'imposto tutti i bit dello shift register senza clokkare sullo shift reg. dei livelli e disattivando SEMPRE il clear dello shift register (valore=2) (xx 01x _1_)
            For ContaLed = 64 To 1 Step -1 'For ContaLed = 1 To 64
                'SHIFT REG. LIVELLI:
                'MSB = 0 --> clock disattivato
                'CENTRALE = 1 (valore=16)--> clear disattivato
                'LSB = indifferente
                
                'SHIFT REG. LED:
                'MSB = 0 --> clock disattivato
                'CENTRALE = 1 (valore=2)--> clear disattivato
                'LSB = StatoCubo(ContaLivelli, ContaLed)
                ByteLpt = (0 + 16 + 0) + (0 + 2 + StatoCubo(ContaLivelli, ContaLed))
                Call ClokkaLed(ByteLpt) 'passo il valore alla funzione che d un colpo di clock allo shift dei led
            Next ContaLed
            
            'SHIFT REG. LIVELLI:
            'MSB = 0 --> clock disattivato
            'CENTRALE = 1 (valore=16)--> clear disattivato
            'LSB = (se livello = 1--> 1(valore=8); se livello <> 1--> 0) --> metto 1 solo la prima volta
            
            'SHIFT REG. LED:
            'MSB = 0 --> clock disattivato
            'CENTRALE = 1 (valore=2)--> clear disattivato
            'LSB = indifferente
            
            If ContaLivelli = 1 Then
                ByteLpt = (0 + 16 + 8) + (0 + 2 + 0)
            Else
                ByteLpt = (0 + 16 + 0) + (0 + 2 + 0)
            End If
            Call ClokkaLivello(ByteLpt) 'passo il valore alla funzione che d un colpo di clock allo shift dei livelli
            
            Call Aspetta(60000) 'smette di lampeggiare dai 60000 ai 70000
        
        Next ContaLivelli
        
        Call ClearAll 'richiamo la funzione per attivare il clear su entrambi gli shift register
        
    Next ContaCicli

End Function

Public Function ClokkaLed(Valore As Byte) 'd un colpo di clock modificando SOLAMENTE il bit del clock
    Out Val(IndirizzoData), Val(Valore) 'clock DISATTIVATO
    'aggiungo 4 perch devo mettere ad 1 il bit del clock dello shift led x dare il colpo di clock
    Out Val(IndirizzoData), Val(Valore + 4) 'clock ATTIVATO
End Function

Public Function ClokkaLivello(Valore As Byte) 'd un colpo di clock modificando SOLAMENTE il bit del clock
    Out Val(IndirizzoData), Val(Valore) 'clock DISATTIVATO
    'aggiungo 32 perch devo mettere ad 1 il bit del clock dello shift livello x dare il colpo di clock
    Out Val(IndirizzoData), Val(Valore + 32) 'clock ATTIVATO
End Function

Public Function ClearAll() 'svuoto tutti gli shift register
Dim ByteLpt As Byte
    'attivo il clear su entrambi gli shift register (valore=0) cos li azzero (xx x0x x0x)
    ByteLpt = 0 '00 000 000
    Out Val(IndirizzoData), Val(ByteLpt)
End Function

Public Function Aspetta(Ncicli As Long) 'funzione per ritardare il ciclo di refresh del cubo
    Dim Contatore As Long
    Dim Contato As Long

    For Contatore = 0 To Ncicli
        Contato = Contatore
    Next Contatore
End Function
