VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EncoderWMA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IEncoder


Private Const Description   As String = "Windows Media Audio"
Private Const Extension     As String = "wma"


Private Declare Function WMCreateProfileManager Lib "wmvcore" ( _
    ppProfile As Any _
) As HRESULT

Private Declare Function WMCreateWriter Lib "wmvcore" ( _
    ByVal pUnkReserved As Long, _
    ppWriter As Any _
) As HRESULT

Private Enum HRESULT
    S_OK = 0
End Enum

Private Enum WMT_VERSION
    WMT_VER_4_0 = &H40000
    WMT_VER_7_0 = &H70000
    WMT_VER_8_0 = &H80000
    WMT_VER_9_0 = &H90000
End Enum

Private Enum WMT_ATTR_DATATYPE
    WMT_TYPE_DWORD = 0
    WMT_TYPE_STRING = 1
    WMT_TYPE_BINARY = 2
    WMT_TYPE_BOOL = 3
    WMT_TYPE_QWORD = 4
    WMT_TYPE_WORD = 5
    WMT_TYPE_GUID = 6
End Enum

Private Enum WMT_ERRORS
    NS_E_NO_MORE_SAMPLES = &HC00D0BCF
End Enum

Private Enum WMT_RIGHTS
    WMT_RIGHT_PLAYBACK = &H1
    WMT_RIGHT_COPY_TO_NON_SDMI_DEVICE = &H2
    WMT_RIGHT_COPY_TO_CD = &H8
    WMT_RIGHT_COPY_TO_SDMI_DEVICE = &H10
    WMT_RIGHT_ONE_TIME = &H20
    WMT_RIGHT_SAVE_STREAM_PROTECTED = &H40
    WMT_RIGHT_COPY = &H80
    WMT_RIGHT_COLLABORATIVE_PLAY = &H100
    WMT_RIGHT_SDMI_TRIGGER = &H10000
    WMT_RIGHT_SDMI_NOMORECOPIES = &H20000
End Enum

Private Type QWORD
    lo                          As Long
    hi                          As Long
End Type

Private Type GUID
    Data1                       As Long
    Data2                       As Integer
    Data3                       As Integer
    Data4(7)                    As Byte
End Type

Private Type IUnknownVT
    QueryInterface              As Long
    AddRef                      As Long
    Release                     As Long
End Type

Private Type IWMWriter
    IUnk                        As IUnknownVT
    SetProfileByID              As Long
    SetProfile                  As Long
    SetOutputFilename           As Long
    GetInputCount               As Long
    GetInputProps               As Long
    SetInputProps               As Long
    GetInputFormatCount         As Long
    GetInputFormat              As Long
    BeginWriting                As Long
    EndWriting                  As Long
    AllocateSample              As Long
    WriteSample                 As Long
    Flush                       As Long
End Type

Private Type INSSBuffer
    IUnk                        As IUnknownVT
    GetLength                   As Long
    SetLength                   As Long
    GetMaxLength                As Long
    GetBuffer                   As Long
    GetBufferAndLength          As Long
End Type

Private Type IWMHeaderInfo
    IUnk                        As IUnknownVT
    GetAttributeCount           As Long
    GetAttributeByIndex         As Long
    GetAttributeByName          As Long
    SetAttribute                As Long
    GetMarkerCount              As Long
    GetMarker                   As Long
    AddMarker                   As Long
    RemoveMarker                As Long
    GetScriptCount              As Long
    GetScript                   As Long
    AddScript                   As Long
    RemoveScript                As Long
End Type

Private Type IWMHeaderInfo2 ' : IWMHeaderInfo
    IUnk                        As IUnknownVT
    GetAttributeCount           As Long
    GetAttributeByIndex         As Long
    GetAttributeByName          As Long
    SetAttribute                As Long
    GetMarkerCount              As Long
    GetMarker                   As Long
    AddMarker                   As Long
    RemoveMarker                As Long
    GetScriptCount              As Long
    GetScript                   As Long
    AddScript                   As Long
    RemoveScript                As Long
    GetCodecInfoCount           As Long
    GetCodecInfo                As Long
End Type

Private Type IWMHeaderInfo3 ' : IWMHeaderInfo2
    IUnk                        As IUnknownVT
    GetAttributeCount           As Long
    GetAttributeByIndex         As Long
    GetAttributeByName          As Long
    SetAttribute                As Long
    GetMarkerCount              As Long
    GetMarker                   As Long
    AddMarker                   As Long
    RemoveMarker                As Long
    GetScriptCount              As Long
    GetScript                   As Long
    AddScript                   As Long
    RemoveScript                As Long
    GetCodecInfoCount           As Long
    GetCodecInfo                As Long
    GetAttributeCountEx         As Long
    GetAttributeIndices         As Long
    GetAttributeByIndexEx       As Long
    ModifyAttribute             As Long
    AddAttribute                As Long
    DeleteAttribute             As Long
    AddCodecInfo                As Long
End Type

Private Type IWMMediaProps
    IUnk                        As IUnknownVT
    GetType                     As Long
    GetMediaType                As Long
    SetMediaType                As Long
End Type

Private Type IWMInputMediaProps ' : IWMMediaProps
    IUnk                        As IUnknownVT
    GetType                     As Long
    GetMediaType                As Long
    SetMediaType                As Long
    GetConnectionName           As Long
    GetGroupName                As Long
End Type

Private Type IWMProfileManager
    IUnk                        As IUnknownVT
    CreateEmtpyProfile          As Long
    LoadProfileByID             As Long
    LoadProfileByData           As Long
    SaveProfile                 As Long
    GetSystemProfileCount       As Long
    LoadSystemProfile           As Long
End Type

Private Type IWMProfile
    IUnk                        As IUnknownVT
    GetVersion                  As Long
    GetName                     As Long
    SetName                     As Long
    GetDescription              As Long
    SetDescription              As Long
    GetStreamCount              As Long
    GetStream                   As Long
    GetStreamByNumber           As Long
    RemoveStream                As Long
    RemoveStreamByNumber        As Long
    AddStream                   As Long
    ReconfigStream              As Long
    CreateNewStream             As Long
    GetMutualExclusionCount     As Long
    AddMutualExclusion          As Long
    CreateNewMutualExclusion    As Long
End Type

Private Type IWMProfile2 ' : IWMProfile
    IUnk                        As IUnknownVT
    GetVersion                  As Long
    GetName                     As Long
    SetName                     As Long
    GetDescription              As Long
    SetDescription              As Long
    GetStreamCount              As Long
    GetStream                   As Long
    GetStreamByNumber           As Long
    RemoveStream                As Long
    RemoveStreamByNumber        As Long
    AddStream                   As Long
    ReconfigStream              As Long
    CreateNewStream             As Long
    GetMutualExclusionCount     As Long
    AddMutualExclusion          As Long
    CreateNewMutualExclusion    As Long
    GetProfileID                As Long
End Type

Private Type IWMProfile3
    IUnk                        As IUnknownVT
    GetVersion                  As Long
    GetName                     As Long
    SetName                     As Long
    GetDescription              As Long
    SetDescription              As Long
    GetStreamCount              As Long
    GetStream                   As Long
    GetStreamByNumber           As Long
    RemoveStream                As Long
    RemoveStreamByNumber        As Long
    AddStream                   As Long
    ReconfigStream              As Long
    CreateNewStream             As Long
    GetMutualExclusionCount     As Long
    AddMutualExclusion          As Long
    CreateNewMutualExclusion    As Long
    GetProfileID                As Long
    GetStorageFormat            As Long
    SetStorageFormat            As Long
    GetBandwidthSharingCount    As Long
    GetBandwidthSharing         As Long
    RemoveBandwidthSharing      As Long
    AddBandwidthSharing         As Long
    CreateNewBandwidthSharing   As Long
    GetStreamPrioritization     As Long
    SetStreamPrioritization     As Long
    RemoveStreamPrioritization  As Long
    CreateNewStreamPrioritization As Long
    GetExpectedPacketCount      As Long
End Type

Private Type IWMCodecInfo
    IUnk                        As IUnknownVT
    GetCodecInfoCount           As Long
    GetCodecFormatCount         As Long
    GetCodecFormat              As Long
End Type

Private Type IWMCodecInfo2
    IUnk                        As IUnknownVT
    GetCodecInfoCount           As Long
    GetCodecFormatCount         As Long
    GetCodecFormat              As Long
    GetCodecName                As Long
    GetCodecFormatDesc          As Long
End Type

Private Type IWMCodecInfo3
    IUnk                        As IUnknownVT
    GetCodecInfoCount           As Long
    GetCodecFormatCount         As Long
    GetCodecFormat              As Long
    GetCodecName                As Long
    GetCodecFormatDesc          As Long
    GetCodecFormatProp          As Long
    GetCodecProp                As Long
    SetCodecEnumerationSetting  As Long
    GetCodecEnumerationSetting  As Long
End Type

Private Type IWMStreamConfig
    IUnk                        As IUnknownVT
    GetStreamType               As Long
    GetStreamNumber             As Long
    SetStreamNumber             As Long
    GetStreamName               As Long
    SetStreamName               As Long
    GetConnectionName           As Long
    SetConnectionName           As Long
    GetBitrate                  As Long
    SetBitrate                  As Long
    GetBufferWindow             As Long
    SetBufferWindow             As Long
End Type

Private Type IWMOutputMediaProps
    IUnk                        As IUnknownVT
    GetType                     As Long
    GetMediaType                As Long
    SetMediaType                As Long
    GetStreamGroupName          As Long
    GetConnectionName           As Long
End Type

Private Type WM_MEDIA_TYPE
    majortype                   As GUID
    subtype                     As GUID
    bFixedSizeSamples           As Long
    bTemporalCompression        As Long
    lSampleSize                 As Long
    formattype                  As GUID
    pUnk                        As Long
    cbFormat                    As Long
    pbFormat                    As Long
End Type


Private Const WMMEDIATYPE_Audio      As String _
    = "{73647561-0000-0010-8000-00AA00389B71}"

Private Const WMMEDIASUBTYPE_PCM     As String _
    = "{00000001-0000-0010-8000-00AA00389B71}"


Private Const WMFORMAT_WaveFormatEx  As String _
    = "{05589f81-c356-11ce-bf01-00aa0055595a}"


Private Const IID_IWMHeaderInfo      As String _
    = "{96406BDA-2B2B-11d3-B36B-00C04F6108FF}"

Private Const IID_IWMHeaderInfo2     As String _
    = "{15CF9781-454E-482e-B393-85FAE487A810}"

Private Const IID_IWMHeaderInfo3     As String _
    = "{15CC68E3-27CC-4ecd-B222-3F5D02D80BD5}"


Private Const IID_IWMProfileManager  As String _
    = "{d16679f2-6ca0-472d-8d31-2f5d55aee155}"

Private Const IID_IWMProfileManager2 As String _
    = "{7A924E51-73C1-494d-8019-23D37ED9B89A}"


Private Const IID_IWMCodecInfo       As String _
    = "{A970F41E-34DE-4a98-B3BA-E4B3CA7528F0}"

Private Const IID_IWMCodecInfo2     As String _
    = "{AA65E273-B686-4056-91EC-DD768D4DF710}"

Private Const IID_IWMCodecInfo3     As String _
    = "{7e51f487-4d93-4f98-8ab4-27d0565adc51}"


Private Const IID_IWMMediaProps      As String _
    = "{96406BCE-2B2B-11d3-B36B-00C04F6108FF}"


Private Const WMMEDIASUBTYPE_DRM     As String _
    = "{00000009-0000-0010-8000-00AA00389B71}"



Private Const IID_IUnknown           As String _
    = "{00000000-0000-0000-C000-000000000046}"

Private Const IID_IWMOutputMediaProps As String _
    = "{96406BD7-2B2B-11d3-B36B-00C04F6108FF}"

Private Const IID_IWMSyncReader      As String _
    = "{9397F121-7705-4dc9-B049-98B698188414}"

Private Const IID_INSSBuffer         As String _
    = "{E1CD3524-03D7-11d2-9EED-006097D2D7CF}"


Private Const attr_WMDuration    As String = "Duration"
Private Const attr_WMBitrate     As String = "Bitrate"
Private Const attr_WMSeekable    As String = "Seekable"
Private Const attr_WMStridable   As String = "Stridable"
Private Const attr_WMBroadcast   As String = "Broadcast"
Private Const attr_WMProtected   As String = "Is_Protected"
Private Const attr_WMTrusted     As String = "Is_Trusted"
Private Const attr_WMSigName     As String = "Signature_Name"
Private Const attr_WMHasAudio    As String = "HasAudio"
Private Const attr_WMHasImage    As String = "HasImage"
Private Const attr_WMHasScript   As String = "HasScript"
Private Const attr_WMHasVideo    As String = "HasVideo"
Private Const attr_WMCurBitrate  As String = "CurrentBitrate"
Private Const attr_WMOptBitrate  As String = "OptimalBitrate"
Private Const attr_WMSkipBackw   As String = "Can_Skip_Backward"
Private Const attr_WMSkipForw    As String = "Can_Skip_Forward"
Private Const attr_WMNumFrames   As String = "NumberOfFrames"
Private Const attr_WMFileSize    As String = "FileSize"

Private Const attr_WMTitle       As String = "Title"
Private Const attr_WMAuthor      As String = "Author"
Private Const attr_WMDescript    As String = "Description"
Private Const attr_WMRating      As String = "Rating"
Private Const attr_WMCopyright   As String = "Copyright"

Private Const attr_WMAlbumTitle  As String = "WM/AlbumTitle"
Private Const attr_WMAlbumArtist As String = "WM/AlbumArtist"
Private Const attr_WMTrack       As String = "WM/Track"
Private Const attr_WMGenre       As String = "WM/Genre"
Private Const attr_WMYear        As String = "WM/Year"
Private Const attr_WMGenreID     As String = "WM/GenreID"
Private Const attr_WMMCDI        As String = "WM/MCDI"
Private Const attr_WMComposer    As String = "WM/Composer"
Private Const attr_WMLyrics      As String = "WM/Lyrics"
Private Const attr_WMTrackNumber As String = "WM/TrackNumber"
Private Const attr_WMIsVBR       As String = "IsVBR"

Private Const g_wszVBREnabled    As String = "_VBRENABLED"
Private Const g_wszNumPasses     As String = "_PASSESUSED"

Private Type WAVEFORMATEX
    wFormatTag              As Integer
    nChannels               As Integer
    nSamplesPerSec          As Long
    nAvgBytesPerSec         As Long
    nBlockAlign             As Integer
    wBitsPerSample          As Integer
    cbSize                  As Integer
End Type

Private pIProfileManager    As Long
Private IProfileManager     As IWMProfileManager

Private pICodecInfo         As Long
Private ICodecInfo3         As IWMCodecInfo3

Private pIWriter            As Long
Private IWriter             As IWMWriter

Private pIStreamCfg         As Long
Private IStreamCfg          As IWMStreamConfig

Private pIProfile           As Long
Private IProfile            As IWMProfile

Private lngSelectedCodec    As Long
Private lngSelectedFormat   As Long

Private dblTime             As Double

Private wfx_inp             As WAVEFORMATEX

Private blnUseVBR           As Boolean

Private Sub Class_Initialize()
    Dim guidCodecInfo3      As GUID

    If Not IsValidFile("wmvcore.dll") Then
        If Not IsValidFile(GetSystemDirectory() & "wmvcore.dll") Then
            Exit Sub
        End If
    End If

    ' create IProfileManager
    If WMCreateProfileManager(pIProfileManager) <> S_OK Then
        Debug.Print "Konnte IWMProfileManager nicht erstellen"
    Else
        ' VTable of IProfileManager
        CpyMem IProfileManager, _
               ByVal DeRefI4(pIProfileManager), _
               Len(IProfileManager)

        guidCodecInfo3 = Str2GUID(IID_IWMCodecInfo3)

        If CallPtr(IProfileManager.IUnk.QueryInterface, _
                   pIProfileManager, _
                   VarPtr(guidCodecInfo3), _
                   VarPtr(pICodecInfo)) <> S_OK Then

            Debug.Print "Konnte IWMCodecInfo3 nicht erstellen"
        Else
            ' VTable of ICodecInfo
            CpyMem ICodecInfo3, _
                   ByVal DeRefI4(pICodecInfo), _
                   Len(ICodecInfo3)
        End If
    End If

    SelectFormat 0, 0
End Sub

Private Sub Class_Terminate()
    If Not pICodecInfo = 0 Then
        CallPtr ICodecInfo3.IUnk.Release, pICodecInfo
    End If

    If Not pIProfileManager = 0 Then
        CallPtr IProfileManager.IUnk.Release, pIProfileManager
    End If
End Sub

' ***************************************
' * Encoder Einstellungen
' ***************************************

Public Property Get VBR( _
) As Boolean

    VBR = blnUseVBR
End Property

Public Property Let VBR( _
    ByVal blnVal As Boolean _
)

    Dim guidType    As GUID
    Dim i           As Long
    Dim ret         As Long
    Dim lngEnabled  As Long

    blnUseVBR = blnVal
    lngEnabled = Abs(blnVal)

    If 0 = pICodecInfo Then Exit Property

    guidType = Str2GUID(WMMEDIATYPE_Audio)

    For i = 0 To GetCodecsCount() - 1
        ' VBR or CBR
        ret = CallPtr(ICodecInfo3.SetCodecEnumerationSetting, _
                pICodecInfo, _
                VarPtr(guidType), _
                i, _
                StrPtr(g_wszVBREnabled), _
                WMT_TYPE_BOOL, _
                VarPtr(lngEnabled), _
                4)

        ' 1-pass
        ret = CallPtr(ICodecInfo3.SetCodecEnumerationSetting, _
                pICodecInfo, _
                VarPtr(guidType), _
                i, _
                StrPtr(g_wszNumPasses), _
                WMT_TYPE_DWORD, _
                VarPtr(1), _
                4)
    Next
End Property

Public Function SelectFormat( _
    ByVal codec As Long, _
    ByVal codec_format As Long _
) As Boolean

    If codec < 0 Or codec > CodecsCount Then
        Exit Function
    End If

    If CodecFormatCount(codec) = 0 Then
        Exit Function
    End If

    If codec_format < 0 Or codec_format > CodecFormatCount(codec) Then
        Exit Function
    End If

    lngSelectedCodec = codec
    lngSelectedFormat = codec_format

    SelectFormat = True
End Function

Public Property Get codecname( _
    Index As Long _
) As String

    codecname = GetCodecName(Index)
End Property

Public Property Get CodecsCount( _
) As Long

    CodecsCount = GetCodecsCount()
End Property

Public Property Get CodecFormatCount( _
    codec As Long _
) As Long

    CodecFormatCount = GetCodecFormatCount(codec)
End Property

Public Property Get CodecFormatName( _
    codec As Long, _
    Index As Long _
) As String

    CodecFormatName = TrimEx(GetCodecFormatName(codec, Index))
End Property

Public Property Get SelectedCodec( _
) As Long

    SelectedCodec = lngSelectedCodec
End Property

Public Property Get SelectedFormat( _
) As Long

    SelectedFormat = lngSelectedFormat
End Property

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Property Let IEncoder_ConfigString( _
    ByVal RHS As String _
)

    Dim strParts()  As String

    If InStr(RHS, " ") < 1 Then Exit Property

    strParts = Split(RHS, " ")
    If strParts(0) <> "WMACFG" Then Exit Property

     lngSelectedCodec = Val(strParts(1))
    lngSelectedFormat = Val(strParts(2))
          blnUseVBR = CBool(strParts(3))
End Property

Private Property Get IEncoder_ConfigString( _
) As String

    IEncoder_ConfigString = "WMACFG " & lngSelectedCodec & " " & _
                                        lngSelectedFormat & " " & _
                                        Abs(blnUseVBR)
End Property

Private Property Get IEncoder_Description( _
) As String

    IEncoder_Description = Description
End Property

Private Property Get IEncoder_Extension( _
) As String

    IEncoder_Extension = Extension
End Property

Private Function IEncoder_Encode( _
    ByVal buffer_ptr As Long, _
    ByVal buffer_len As Long, _
    buffer_used As Long _
) As SND_RESULT

    Dim qwTime      As QWORD
    Dim strHexTime  As String
    Dim pIBuffer    As Long
    Dim IBuffer     As INSSBuffer
    Dim pBuffer     As Long
    Dim hr          As HRESULT

    If buffer_len > IEncoder_EncoderMetrics(ENC_M_PCM_PER_DELIVERY_MAX) Then
        IEncoder_Encode = SND_ERR_INVALID_BUFFER
        Exit Function
    ElseIf buffer_len < IEncoder_EncoderMetrics(ENC_M_PCM_PER_DELIVERY_MIN) Then
        IEncoder_Encode = SND_ERR_INVALID_BUFFER
        Exit Function
    End If

    If buffer_ptr = 0 Then
        IEncoder_Encode = SND_ERR_INVALID_BUFFER
        Exit Function
    End If

    If pIWriter = 0 Then
        IEncoder_Encode = SND_ERR_INTERNAL
        Exit Function
    End If

    ' new INSSBuffer instance
    hr = CallPtr(IWriter.AllocateSample, _
                 pIWriter, _
                 buffer_len, _
                 VarPtr(pIBuffer))

    If hr <> S_OK Then
        IEncoder_Encode = SND_ERR_INTERNAL
        Exit Function
    End If

    ' INSSBuffer VTable
    CpyMem IBuffer, _
           ByVal DeRefI4(pIBuffer), _
           Len(IBuffer)

    ' get the pointer to the INSSBuffer buffer
    hr = CallPtr(IBuffer.GetBuffer, _
                 pIBuffer, _
                 VarPtr(pBuffer))

    ' fill the buffer
    CpyMem ByVal pBuffer, _
           ByVal buffer_ptr, _
           buffer_len

    ' split the time into 2 DWORDs,
    ' because IWriter.WriteSample wants a QWORD.
    ' VB doesn't support QWORDs, so just use 2 DWORDs.
    strHexTime = FmtStrLen(DecToHex(dblTime), 16)
    qwTime.lo = Val("&H" & Right$(strHexTime, 8) & "&")
    qwTime.hi = Val("&H" & Left$(strHexTime, 8) & "&")

    ' encode samples
    hr = CallPtr(IWriter.WriteSample, _
                 pIWriter, _
                 0, _
                 qwTime.lo, _
                 qwTime.hi, _
                 0, _
                 pIBuffer)

    If hr = S_OK Then
        IEncoder_Encode = SND_ERR_SUCCESS
        buffer_used = buffer_len
    Else
        IEncoder_Encode = SND_ERR_WRITE_ERROR
        buffer_used = 0
    End If

    ' current position in 100-nanoseconds
    With wfx_inp
        dblTime = dblTime + Fix((buffer_len / .nAvgBytesPerSec) / 10 ^ -7)
    End With

    ' Set IBuffer = Nothing
    CallPtr IBuffer.IUnk.Release, pIBuffer
End Function

Private Function IEncoder_EncoderClose( _
) As SND_RESULT

    If pIWriter = 0 Then
        IEncoder_EncoderClose = SND_ERR_INTERNAL
        Exit Function
    End If

    CallPtr IWriter.EndWriting, pIWriter
    CallPtr IWriter.IUnk.Release, pIWriter
    pIWriter = 0

    CallPtr IProfile.IUnk.Release, pIProfile
    pIProfile = 0

    CallPtr IStreamCfg.IUnk.Release, pIStreamCfg
    pIStreamCfg = 0

    dblTime = 0

    ZeroMem wfx_inp, Len(wfx_inp)

    IEncoder_EncoderClose = SND_ERR_SUCCESS
End Function

Private Function IEncoder_EncoderInit( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    ByVal output As String, _
    tags As StreamTags _
) As SND_RESULT

    Dim piInpProps  As Long
    Dim IInpProps   As IWMInputMediaProps
    Dim cFormats    As Long
    Dim cbSize      As Long
    Dim btMedia()   As Byte
    Dim guidFormat  As GUID
    Dim udtMedia    As WM_MEDIA_TYPE
    Dim udtWFX      As WAVEFORMATEX
    Dim intNumber   As Integer
    Dim i           As Long

    IEncoder_EncoderInit = SND_ERR_INVALID_PARAM

    If lngSelectedCodec = -1 Then
        Exit Function
    End If

    If lngSelectedFormat = -1 Then
        Exit Function
    End If

    If samplerate < 2 Then
        Exit Function
    End If

    If Channels < 1 Or Channels > 2 Then
        Exit Function
    End If

    If output = "" Then
        Exit Function
    End If

    IEncoder_EncoderClose

    guidFormat = Str2GUID(WMMEDIATYPE_Audio)

    ' get Stream Config
    If S_OK <> CallPtr(ICodecInfo3.GetCodecFormat, _
                       pICodecInfo, _
                       VarPtr(guidFormat), _
                       lngSelectedCodec, _
                       lngSelectedFormat, _
                       VarPtr(pIStreamCfg)) Then

        Debug.Print "Konnte IWMStreamConfig nicht holen"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    ' IWMStreamConfig VTable
    CpyMem IStreamCfg, _
           ByVal DeRefI4(pIStreamCfg), _
           Len(IStreamCfg)

    CallPtr IStreamCfg.GetStreamNumber, pIStreamCfg, VarPtr(intNumber)

    If S_OK <> CallPtr(IStreamCfg.SetStreamNumber, pIStreamCfg, 1) Then
        Debug.Print "Konnte Stream Number nicht setzen"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    ' create a new profile
    If S_OK <> CallPtr(IProfileManager.CreateEmtpyProfile, _
                       pIProfileManager, _
                       WMT_VER_9_0, _
                       VarPtr(pIProfile)) Then

        Debug.Print "Konnte IWMProfile nicht instanzieren"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    ' IWMProfile VTable
    CpyMem IProfile, _
           ByVal DeRefI4(pIProfile), _
           Len(IProfile)

    ' add the stream config to the profile
    If S_OK <> CallPtr(IProfile.AddStream, _
                       pIProfile, _
                       pIStreamCfg) Then

        Debug.Print "Konnte Stream nicht hinzufgen"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    ' create a new IWMWriter
    If WMCreateWriter(0, pIWriter) <> S_OK Then
        Debug.Print "Konnte IWMWriter nicht instanzieren"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    ' IWMWriter VTable
    CpyMem IWriter, _
           ByVal DeRefI4(pIWriter), _
           Len(IWriter)

    If S_OK <> CallPtr(IWriter.SetProfile, _
                       pIWriter, _
                       pIProfile) Then

        Debug.Print "Konnte Input nicht setzen"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    ' set output filename
    If S_OK <> CallPtr(IWriter.SetOutputFilename, _
                       pIWriter, _
                       StrPtr(output)) Then

        Debug.Print "Konnte Datei nicht setzen"
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    With wfx_inp
        .nSamplesPerSec = samplerate
        .nChannels = Channels
        .wBitsPerSample = 16
        .nBlockAlign = .nChannels * (.wBitsPerSample / 8)
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    End With

    ' number of inputs for the input stream
    CallPtr IWriter.GetInputFormatCount, _
            pIWriter, _
            0, _
            VarPtr(cFormats)

    For i = 0 To cFormats - 1
        ' IWMInputMediaProps of current format
        If S_OK <> CallPtr(IWriter.GetInputFormat, _
                           pIWriter, _
                           0, _
                           i, _
                           VarPtr(piInpProps)) Then

            GoTo NextFormat
        End If

        ' IWMInputMediaProps VTable
        CpyMem IInpProps, _
               ByVal DeRefI4(piInpProps), _
               Len(IInpProps)

        ' WM_MEDIA_TYPE of the format
        CallPtr IInpProps.GetMediaType, _
                piInpProps, _
                0, _
                VarPtr(cbSize)

        ReDim btMedia(cbSize - 1) As Byte

        CallPtr IInpProps.GetMediaType, _
                piInpProps, _
                VarPtr(btMedia(0)), _
                VarPtr(cbSize)

        CpyMem udtMedia, btMedia(0), Len(udtMedia)

        ' PCM Format?
        If GUIDEqual(udtMedia.subtype, Str2GUID(WMMEDIASUBTYPE_PCM)) Then
            CpyMem udtWFX, ByVal udtMedia.pbFormat, Len(udtWFX)

            If udtWFX.nSamplesPerSec = samplerate Then
                If udtWFX.nChannels = Channels Then
                    If udtWFX.wBitsPerSample = 16 Then

                        ' set input format
                        If S_OK <> CallPtr(IInpProps.SetMediaType, _
                                           piInpProps, _
                                           VarPtr(btMedia(0))) Then

                            GoTo NextFormat
                        End If

                        If S_OK <> CallPtr(IWriter.SetInputProps, _
                                           pIWriter, _
                                           0, _
                                           piInpProps) Then

                            GoTo NextFormat
                        End If

                        AddTags tags

                        ' start the encoder
                        If S_OK = CallPtr(IWriter.BeginWriting, _
                                          pIWriter) Then

                            IEncoder_EncoderInit = SND_ERR_SUCCESS
                            Exit Function
                        End If

                    End If
                End If
            End If
        End If

NextFormat:
    Next

    IEncoder_EncoderInit = SND_ERR_INTERNAL
End Function

Private Function IEncoder_EncoderMetrics( _
    ByVal info As ENCODER_METRICS _
) As Long

    Select Case info
        Case ENC_M_PCM_PER_DELIVERY_MAX
            IEncoder_EncoderMetrics = wfx_inp.nAvgBytesPerSec
        Case ENC_M_PCM_PER_DELIVERY_MIN
            IEncoder_EncoderMetrics = wfx_inp.nBlockAlign
        Case ENC_M_SUPPORT_TAGS
            IEncoder_EncoderMetrics = ENC_TAG_ALBUM Or _
                                      ENC_TAG_ARTIST Or _
                                      ENC_TAG_COMMENT Or _
                                      ENC_TAG_GENRE Or _
                                      ENC_TAG_TITLE Or _
                                      ENC_TAG_TRACK_NUM Or _
                                      ENC_TAG_YEAR
    End Select
End Function

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub AddTags( _
    ByVal tags As StreamTags _
)

    Dim clsTag  As StreamTag
    Dim i       As Long

    For i = 1 To tags.TagCount
        Set clsTag = tags.TagItem(i)
        Select Case LCase$(clsTag.TagName)
            Case "artist"
                WMAAddTag attr_WMAlbumArtist, clsTag.TagValue
                WMAAddTag attr_WMAuthor, clsTag.TagValue
                WMAAddTag "WM/Artist", clsTag.TagValue
            Case "album"
                WMAAddTag attr_WMAlbumTitle, clsTag.TagValue
            Case "title"
                WMAAddTag attr_WMTitle, clsTag.TagValue
            Case "tracknumber"
                WMAAddTag attr_WMTrackNumber, clsTag.TagValue
                WMAAddTag attr_WMTrack, clsTag.TagValue
            Case "comment"
                WMAAddTag attr_WMDescript, clsTag.TagValue
            Case "genre"
                WMAAddTag attr_WMGenre, clsTag.TagValue
            Case "year"
                WMAAddTag attr_WMYear, clsTag.TagValue
        End Select
    Next
End Sub

Private Sub WMAAddTag( _
    ByVal strAttribute As String, _
    ByVal strValue As String _
)

    Dim hr          As HRESULT
    Dim iidHdr      As GUID

    Dim pIHeader    As Long
    Dim IHeader     As IWMHeaderInfo3

    Dim pwIndex     As Integer

    ' get IWMHeaderInfo3 from IWMWriter
    iidHdr = Str2GUID(IID_IWMHeaderInfo3)

    hr = CallPtr(IWriter.IUnk.QueryInterface, _
                 pIWriter, _
                 VarPtr(iidHdr), _
                 VarPtr(pIHeader))

    If hr <> S_OK Then Exit Sub

    ' VTable of IWMHeaderInfo3
    CpyMem IHeader, ByVal DeRefI4(pIHeader), Len(IHeader)

    ' write the attribute
    hr = CallPtr(IHeader.AddAttribute, _
                 pIHeader, _
                 0, _
                 StrPtr(strAttribute), _
                 VarPtr(pwIndex), _
                 WMT_TYPE_STRING, _
                 0, _
                 StrPtr(strValue), _
                 LenB(strValue) + 2)

    ' Set IHeader = Nothing
    CallPtr IHeader.IUnk.Release, pIHeader
End Sub

Private Function GetCodecsCount( _
) As Long

    Dim cCodecs     As Long
    Dim guidFormat  As GUID

    guidFormat = Str2GUID(WMMEDIATYPE_Audio)

    ''' BUG !!!
    If S_OK = CallPtr(ICodecInfo3.GetCodecInfoCount, _
                      pICodecInfo, _
                      VarPtr(guidFormat), _
                      VarPtr(cCodecs)) Then

        GetCodecsCount = cCodecs
    End If
End Function

Private Function GetCodecName( _
    Index As Long _
) As String

    Dim strName     As String
    Dim cChars      As Long
    Dim guidFormat  As GUID

    strName = Space(255)
    cChars = Len(strName)

    guidFormat = Str2GUID(WMMEDIATYPE_Audio)

    CallPtr ICodecInfo3.GetCodecName, _
            pICodecInfo, _
            VarPtr(guidFormat), _
            Index, _
            StrPtr(strName), _
            VarPtr(cChars)

    GetCodecName = TrimEx(strName)
End Function

Private Function GetCodecFormatName( _
    codec As Long, _
    Index As Long _
) As String

    Dim guidFormat  As GUID
    Dim strFormat   As String
    Dim cChars      As Long

    guidFormat = Str2GUID(WMMEDIATYPE_Audio)

    CallPtr ICodecInfo3.GetCodecFormatDesc, _
            pICodecInfo, _
            VarPtr(guidFormat), _
            codec, _
            Index, _
            0, 0, _
            VarPtr(cChars)

    strFormat = Space(cChars)

    CallPtr ICodecInfo3.GetCodecFormatDesc, _
            pICodecInfo, _
            VarPtr(guidFormat), _
            codec, _
            Index, _
            0, _
            StrPtr(strFormat), _
            VarPtr(cChars)

    GetCodecFormatName = strFormat
End Function

Private Function GetCodecFormatCount( _
    Index As Long _
) As Long

    Dim cFormats    As Long
    Dim guidFormat  As GUID

    guidFormat = Str2GUID(WMMEDIATYPE_Audio)

    If S_OK = CallPtr(ICodecInfo3.GetCodecFormatCount, _
                      pICodecInfo, _
                      VarPtr(guidFormat), _
                      Index, _
                      VarPtr(cFormats)) Then

        GetCodecFormatCount = cFormats
    End If
End Function

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Function CallPtr( _
    ByVal fnc As Long, _
    ParamArray Params() _
) As Long

    Dim btASM(&HEC00& - 1)  As Byte
    Dim pASM                As Long
    Dim i                   As Integer

    pASM = VarPtr(btASM(0))

    AddByte pASM, &H58                  ' POP EAX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H50                  ' PUSH EAX

    If UBound(Params) = 0 Then
        If IsArray(Params(0)) Then
            For i = UBound(Params(0)) To 0 Step -1
                AddPush pASM, CLng(Params(0)(i))    ' PUSH dword
            Next
        Else
            For i = UBound(Params) To 0 Step -1
                AddPush pASM, CLng(Params(i))       ' PUSH dword
            Next
        End If
    Else
        For i = UBound(Params) To 0 Step -1
            AddPush pASM, CLng(Params(i))           ' PUSH dword
        Next
    End If

    AddCall pASM, fnc                   ' CALL rel addr
    AddByte pASM, &HC3                  ' RET

    CallPtr = CallWindowProc(VarPtr(btASM(0)), _
                             0, 0, 0, 0)
End Function

Private Sub AddPush( _
    pASM As Long, _
    lng As Long _
)

    AddByte pASM, &H68
    AddLong pASM, lng
End Sub

Private Sub AddCall( _
    pASM As Long, _
    addr As Long _
)

    AddByte pASM, &HE8
    AddLong pASM, addr - pASM - 4
End Sub

Private Sub AddLong( _
    pASM As Long, _
    lng As Long _
)

    CpyMem ByVal pASM, lng, 4
    pASM = pASM + 4
End Sub

Private Sub AddByte( _
    pASM As Long, _
    Bt As Byte _
)

    CpyMem ByVal pASM, Bt, 1
    pASM = pASM + 1
End Sub

Private Function DeRefI4( _
    ByVal ptr As Long _
) As Long

    CpyMem DeRefI4, ByVal ptr, 4
End Function

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Function Str2GUID( _
    strGUID As String _
) As GUID

    Dim G           As GUID
    Dim strParts()  As String

    strParts = Split(Mid$(strGUID, 2, Len(strGUID) - 2), "-")

    G.Data1 = Val("&H" & strParts(0))
    G.Data2 = Val("&H" & strParts(1))
    G.Data3 = Val("&H" & strParts(2))
    G.Data4(0) = Val("&H" & Mid$(strParts(3), 1, 2))
    G.Data4(1) = Val("&H" & Mid$(strParts(3), 3, 2))
    G.Data4(2) = Val("&H" & Mid$(strParts(4), 1, 2))
    G.Data4(3) = Val("&H" & Mid$(strParts(4), 3, 2))
    G.Data4(4) = Val("&H" & Mid$(strParts(4), 5, 2))
    G.Data4(5) = Val("&H" & Mid$(strParts(4), 7, 2))
    G.Data4(6) = Val("&H" & Mid$(strParts(4), 9, 2))
    G.Data4(7) = Val("&H" & Mid$(strParts(4), 11, 2))

    Str2GUID = G
End Function

Private Function GUIDEqual( _
    guid1 As GUID, _
    guid2 As GUID _
) As Boolean

    If guid1.Data1 = guid2.Data1 Then
        If guid1.Data2 = guid2.Data2 Then
            If guid1.Data3 = guid2.Data3 Then
                If StrConv(guid1.Data4, vbUnicode) = StrConv(guid2.Data4, vbUnicode) Then
                    GUIDEqual = True
                End If
            End If
        End If
    End If
End Function
