VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FreeDB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' http://vbaccelerator.com/home/VB/Code/vbMedia/Audio/CD_Tracklistings/article.asp

Private Type QOCINFO
    dwSize          As Long
    dwFlags         As Long
    dwInSpeed       As Long
    dwOutSpeed      As Long
End Type

Private Enum NetworkAliveFlags
   NETWORK_ALIVE_LAN = &H1&
   NETWORK_ALIVE_WAN = &H2&
   NETWORK_ALIVE_AOL = &H4&
End Enum

Private Declare Function IsNetworkAlive Lib "Sensapi.dll" ( _
      ByVal lpdwFlags As NetworkAliveFlags _
   ) As Long

Private Declare Function IsDestinationReachableA Lib "Sensapi.dll" ( _
      ByVal lpszDestination As String, _
      lpQOCInfo As Any _
    ) As Long

Private WithEvents m_tmr As clsTimer
Attribute m_tmr.VB_VarHelpID = -1

Private m_xHttp As ServerXMLHTTP

Public Enum EXmlHttpReadyState
    Uninitialised = 0
    Loading = 1
    Loaded = 2
    Interactive = 3
    Completed = 4
End Enum

Private m_sServer       As String
Private m_sUrl          As String
Private m_sUserName     As String
Private m_sUserHost     As String
Private m_sAgentName    As String
Private m_sAgentVersion As String
Private m_sCommand      As String
Private m_sResponse     As String
Private m_bQueryRunning As Boolean

Public Event CommandReady()

Private Property Get SensApiAvailable( _
) As Boolean

    Dim hLoad As Long

    hLoad = LoadLibrary("sensapi.dll")
    If Not (hLoad = 0) Then
        If Not (GetProcAddress(hLoad, "IsNetworkAlive") = 0) Then
            SensApiAvailable = True
        End If
        FreeLibrary hLoad
    End If
End Property

Public Property Get CanConnect( _
) As Boolean

    If (SensApiAvailable()) Then ' IE5+ only
        If Not (IsNetworkAlive(NETWORK_ALIVE_WAN) = 0) Then
            Dim sUrl As String
            sUrl = m_sServer & m_sUrl
            If Not (IsDestinationReachableA(sUrl, ByVal 0&) = 0) Then
                CanConnect = True
            End If
        End If
    End If
End Property

Public Property Get Server( _
) As String

    Server = m_sServer
End Property

Public Property Let Server( _
    ByVal Value As String _
)

    m_sServer = Value
End Property

Public Property Get Url( _
) As String

    Url = m_sUrl
End Property

Public Property Let Url( _
    ByVal Value As String _
)

    m_sUrl = Value
End Property

Public Property Get UserName( _
) As String

    UserName = m_sUserName
End Property

Public Property Let UserName( _
    ByVal Value As String _
)

    m_sUserName = Value
End Property

Public Property Get UserHost( _
) As String

    UserHost = m_sUserHost
End Property
Public Property Let UserHost( _
    ByVal Value As String _
)

    m_sUserHost = Value
End Property

Public Property Get AgentName( _
) As String

    AgentName = m_sAgentName
End Property

Public Property Let AgentName( _
    ByVal Value As String _
)

    m_sAgentName = Value
End Property

Public Property Get AgentVersion( _
) As String

    AgentVersion = m_sAgentVersion
End Property

Public Property Let AgentVersion( _
    ByVal Value As String _
)

    m_sAgentVersion = Value
End Property

Public Property Get command( _
) As String

    command = m_sCommand
End Property

Public Property Let command( _
    ByVal Value As String _
)

    m_sCommand = Value
End Property

Public Property Get Response( _
) As String

    Response = m_sResponse
End Property

Public Sub start()
    On Error GoTo ErrorHandler

    If (m_bQueryRunning) Then
        Err.Raise vbObjectError + 4096 + 1, App.EXEName & ".cFreeDB", "Query already in progress"
    Else
        m_sResponse = ""
        Dim sUrl As String
        sUrl = UrlBit & parse(m_sCommand) & HelloBit
        m_xHttp.Open "GET", sUrl, True
        m_xHttp.Send
        m_bQueryRunning = True
        m_tmr.Interval = 50
        m_tmr.Enabled = True
    End If

    Exit Sub

ErrorHandler:
    m_tmr.Enabled = False
    m_bQueryRunning = False
    RaiseEvent CommandReady
End Sub

Public Property Get CommandSubmitted( _
) As Boolean

    CommandSubmitted = m_bQueryRunning
End Property

Public Sub Abort()
    If (m_bQueryRunning) Then
        If (m_bQueryRunning) Then
            m_tmr.Enabled = False
            m_xHttp.Abort
        End If
    End If
End Sub

Private Sub Class_Initialize()
    m_sAgentName = "Monoton2"
    m_sAgentVersion = "1.0"
    m_sUserName = "rm"
    m_sUserHost = "rm_code.dl.am"

    m_sServer = "http://freedb.freedb.org/"
    m_sUrl = "~cddb/cddb.cgi"

    Set m_xHttp = New ServerXMLHTTP
    Set m_tmr = New clsTimer
End Sub

Private Function UrlBit( _
) As String

    Dim sUrlBit As String

    sUrlBit = m_sServer
    sUrlBit = sUrlBit & m_sUrl
    sUrlBit = sUrlBit & "?cmd="
    UrlBit = sUrlBit
End Function

Private Function HelloBit( _
) As String

    Dim sHelloBit As String

    sHelloBit = "&hello="
    sHelloBit = sHelloBit & parse(m_sUserName)
    sHelloBit = sHelloBit & "+" & parse(m_sUserHost)
    sHelloBit = sHelloBit & "+" & parse(m_sAgentName)
    sHelloBit = sHelloBit & "+" & parse(m_sAgentVersion)
    sHelloBit = sHelloBit & "&proto=1"
    HelloBit = sHelloBit
End Function

Private Function parse( _
    ByVal sGetUrl _
) As String

    Dim i       As Long
    Dim B()     As Byte
    Dim sRet    As String

    B = StrConv(sGetUrl, vbFromUnicode)

    For i = LBound(B) To UBound(B)
       Select Case B(i)
       Case 0 To 9
          ' non-printing codes:
          sRet = "%0" & Hex(B)
       Case 10 To 31
          ' non-printing codes:
          sRet = "%" & Hex(B)
       Case 32
          ' space
          sRet = sRet & "+"
       Case 33 To 45, 47
          ' codes which can affect URLs
          sRet = "%" & Hex(B)
       Case 46
          ' full stop
          sRet = sRet & "."
       Case 48 To 57
          ' numbers:
          sRet = sRet & Chr(B(i))
       Case 58 To 64
          ' codes which can affect URLs
          sRet = "%" & Hex(B)
       Case 65 To 90
          ' upper case letters
          sRet = sRet & Chr(B(i))
       Case 91 To 96
          ' codes which affect URLs
          sRet = "%" & Hex(B(i))
       Case 97 To 122
          ' lower case letters
          sRet = sRet & Chr(B(i))
       Case 126 To 255
          ' codes which affect URLs
          sRet = "%" & Hex(B)
       End Select
    Next i

    parse = sRet
End Function

Private Sub Class_Terminate()
    Abort
    Set m_tmr = Nothing
    Set m_xHttp = Nothing
End Sub

Private Sub m_tmr_Timer()
    If (m_xHttp.readyState = Completed) Then
        m_tmr.Enabled = False
        m_bQueryRunning = False
        Dim B() As Byte
        B = m_xHttp.responseBody
        m_sResponse = StrConv(B, vbUnicode)
        RaiseEvent CommandReady
    End If
End Sub

Public Property Get QueryResponse( _
) As FreeDBQueryResponse

    Dim cF As New FreeDBQueryResponse
    cF.fInit m_sResponse
    Set QueryResponse = cF
End Property

Public Property Get ReadResponse( _
) As FreeDBReadResponse

    Dim cR As New FreeDBReadResponse
    cR.fInit m_sResponse
    Set ReadResponse = cR
End Property
