VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistReader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private clsReaders()    As IPlaylistReader
Private clsReader       As IPlaylistReader
Private lngReaderCnt    As Long

Private Sub AddReader( _
    reader As IPlaylistReader _
)

    ReDim Preserve clsReaders(lngReaderCnt) As IPlaylistReader
    Set clsReaders(lngReaderCnt) = reader
    lngReaderCnt = lngReaderCnt + 1
End Sub

Private Sub Class_Initialize()
    AddReader New PlaylistReaderM3U
    AddReader New PlaylistReaderPLS
End Sub

Public Function GetExtensions( _
) As String()

    Dim strExts()   As String
    Dim i           As Long

    ReDim strExts(lngReaderCnt - 1) As String

    For i = 0 To lngReaderCnt - 1
        strExts(i) = clsReaders(i).Extension
    Next

    GetExtensions = strExts
End Function

Public Property Get FileCount( _
) As Long

    FileCount = clsReader.Files
End Property

Public Sub GetFile( _
    ByVal Index As Long, _
    ByRef file As String, _
    ByRef title As String, _
    ByRef Length As Long _
)

    clsReader.GetFile Index, file, title, Length
End Sub

Public Function OpenPlaylist( _
    ByVal Source As String _
) As Boolean

    Dim i       As Long
    Dim strFExt As String

    strFExt = Mid$(Source, InStrRev(Source, ".") + 1)

    For i = 0 To lngReaderCnt - 1
        If StrComp(clsReaders(i).Extension, strFExt, vbTextCompare) = 0 Then
            Set clsReader = clsReaders(i)
            OpenPlaylist = clsReader.OpenPlaylist(Source)
        End If
    Next
End Function
