Attribute VB_Name = "modMixer"
Option Explicit

Public Declare Function mixerGetControlDetails Lib "winmm" _
Alias "mixerGetControlDetailsA" ( _
    ByVal hmxobj As Long, _
    pmxcd As MIXERCONTROLDETAILS, _
    ByVal fdwDetails As Long _
) As Long

Public Declare Function mixerGetLineControls Lib "winmm" _
Alias "mixerGetLineControlsA" ( _
    ByVal hmxobj As Long, _
    pmxlc As MIXERLINECONTROLS, _
    ByVal fdwControls As Long _
) As Long

Public Declare Function mixerGetLineInfo Lib "winmm" _
Alias "mixerGetLineInfoA" ( _
    ByVal hmxobj As Long, _
    pmxl As MIXERLINE, _
    ByVal fdwInfo As Long _
) As Long

Public Declare Function mixerSetControlDetails Lib "winmm" ( _
    ByVal hmxobj As Long, _
    pmxcd As MIXERCONTROLDETAILS, _
    ByVal fdwDetails As Long _
) As Long

Public Declare Function mixerGetDevCaps Lib "winmm.dll" _
Alias "mixerGetDevCapsA" ( _
    ByVal uMxId As Long, _
    pmxcaps As MIXERCAPS, _
    ByVal cbmxcaps As Long _
) As Long

Public Declare Sub CopyStructFromPtr Lib "kernel32" _
Alias "RtlMoveMemory" ( _
    struct As Any, _
    ByVal ptr As Long, _
    ByVal cb As Long _
)

Public Declare Sub CopyPtrFromStruct Lib "kernel32" _
Alias "RtlMoveMemory" ( _
    ByVal ptr As Long, _
    struct As Any, _
    ByVal cb As Long _
)

Public Const MAXPNAMELEN                               As Long = 32

Public Const MIXER_GETCONTROLDETAILSF_LISTTEXT         As Long = &H1&
Public Const MIXER_GETCONTROLDETAILSF_VALUE            As Long = &H0&

Public Const MIXER_GETLINECONTROLSF_ONEBYTYPE          As Long = &H2&
    
Public Const MIXER_GETLINEINFOF_COMPONENTTYPE          As Long = &H3&
Public Const MIXER_GETLINEINFOF_LINEID                 As Long = &H2&
Public Const MIXER_GETLINEINFOF_SOURCE                 As Long = &H1&
Public Const MIXER_GETLINEINFOF_DESTINATION            As Long = &H0&

Public Const MIXER_LONG_NAME_CHARS                     As Long = 64
Public Const MIXER_SHORT_NAME_CHARS                    As Long = 16

Public Const MIXERCONTROL_CONTROLTYPE_VOLUME           As Long = &H50030001
Public Const MIXERCONTROL_CONTROLTYPE_MUTE             As Long = &H20010002

Public Const MIXER_SETCONTROLDETAILSF_VALUE            As Long = &H0&

Public Const MIXERCONTROL_CT_UNITS_BOOLEAN             As Long = &H10000
Public Const MIXERCONTROL_CT_SC_LIST_MULTIPLE          As Long = &H1000000
Public Const MIXERCONTROL_CT_SC_LIST_SINGLE            As Long = 0
Public Const MIXERCONTROL_CT_CLASS_LIST                As Long = &H70000000

Public Const MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT   As Long = (MIXERCONTROL_CT_CLASS_LIST Or MIXERCONTROL_CT_SC_LIST_MULTIPLE Or MIXERCONTROL_CT_UNITS_BOOLEAN)
Public Const MIXERCONTROL_CONTROLTYPE_SINGLESELECT     As Long = (MIXERCONTROL_CT_CLASS_LIST Or MIXERCONTROL_CT_SC_LIST_SINGLE Or MIXERCONTROL_CT_UNITS_BOOLEAN)

Public Const MIXERCONTROL_CONTROLTYPE_MIXER            As Long = (MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1)
Public Const MIXERCONTROL_CONTROLTYPE_MUX              As Long = (MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1)

Public Const MIXERLINE_COMPONENTTYPE_DST_FIRST = &H0&
Public Const MIXERLINE_COMPONENTTYPE_DST_DIGITAL = &H1&
Public Const MIXERLINE_COMPONENTTYPE_DST_HEADPHONES = &H5&
Public Const MIXERLINE_COMPONENTTYPE_DST_LAST = &H8&
Public Const MIXERLINE_COMPONENTTYPE_DST_LINE = &H2&
Public Const MIXERLINE_COMPONENTTYPE_DST_MONITOR = &H3&
Public Const MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = &H4&
Public Const MIXERLINE_COMPONENTTYPE_DST_TELEPHONE = &H6&
Public Const MIXERLINE_COMPONENTTYPE_DST_UNDEFINED = &H0&
Public Const MIXERLINE_COMPONENTTYPE_DST_VOICEIN = &H8&
Public Const MIXERLINE_COMPONENTTYPE_DST_WAVEIN = &H7&

Public Const MIXERLINE_COMPONENTTYPE_SRC_FIRST = &H1000&
Public Const MIXERLINE_COMPONENTTYPE_SRC_ANALOG = &H100A&
Public Const MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY = &H1009&
Public Const MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC = &H1005&
Public Const MIXERLINE_COMPONENTTYPE_SRC_DIGITAL = &H1001&
Public Const MIXERLINE_COMPONENTTYPE_SRC_LAST = &H100A&
Public Const MIXERLINE_COMPONENTTYPE_SRC_LINE = &H1002&
Public Const MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE = &H1003&
Public Const MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER = &H1007&
Public Const MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER = &H1004&
Public Const MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE = &H1006&
Public Const MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED = &H1000&
Public Const MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT = &H1008&

Public Type MIXERCONTROLDETAILS_LISTTEXT
    dwParam1                                    As Long
    dwParam2                                    As Long
    szName                                      As Long
End Type

Public Type MIXERCONTROL
    cbStruct                                    As Long
    dwControlID                                 As Long
    dwControlType                               As Long
    fdwControl                                  As Long
    cMultipleItems                              As Long
    szShortName(MIXER_SHORT_NAME_CHARS / 2 - 1) As Integer
    szName(MIXER_LONG_NAME_CHARS / 2 - 1)       As Integer
    Bounds(5)                                   As Long
    Metrics(5)                                  As Long
End Type

Public Type MIXERCONTROLDETAILS
    cbStruct                                    As Long
    dwControlID                                 As Long
    cChannels                                   As Long
    item                                        As Long
    cbDetails                                   As Long
    paDetails                                   As Long
End Type

Public Type Target
    dwType                                      As Long
    dwDeviceID                                  As Long
    wMid                                        As Integer
    wPid                                        As Integer
    vDriverVersion                              As Long
    szPname                                     As String * MAXPNAMELEN
End Type

Public Type MIXERLINE
    cbStruct                                    As Long
    dwDestination                               As Long
    dwSource                                    As Long
    dwLineID                                    As Long
    fdwLine                                     As Long
    dwUser                                      As Long
    dwComponentType                             As Long
    cChannels                                   As Long
    cConnections                                As Long
    cControls                                   As Long
    szShortName                                 As String * MIXER_SHORT_NAME_CHARS
    szName                                      As String * MIXER_LONG_NAME_CHARS
    tTarget                                     As Target
End Type

Public Type MIXERLINECONTROLS
    cbStruct                                    As Long
    dwLineID                                    As Long
    dwControl                                   As Long
    cControls                                   As Long
    cbmxctrl                                    As Long
    pamxctrl                                    As Long
End Type

Type MIXERCAPS
    wMid                                        As Integer
    wPid                                        As Integer
    vDriverVersion                              As Long
    szPname                                     As String * 32
    fdwSupport                                  As Long
    cDestinations                               As Long
End Type

Private Type MIXERCONTROLDETAILS_BOOLEAN
     fValue                                     As Long
End Type

Public Type volume_stereo
    L                                           As Long
    R                                           As Long
End Type

Public Sub MixerSetDestinationVolume( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    vol As volume_stereo _
)

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_DESTINATION

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_VOLUME, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = udtML.cChannels
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(vol)
    End With

    mixerSetControlDetails deviceid, udtMCL, MIXER_SETCONTROLDETAILSF_VALUE
End Sub

Public Sub MixerSetConnectionVolume( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal connection As Long, _
    vol As volume_stereo _
)

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination
    udtML.dwSource = connection

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_SOURCE

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_VOLUME, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = udtML.cChannels
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(vol)
    End With

    mixerSetControlDetails deviceid, _
                           udtMCL, _
                           MIXER_SETCONTROLDETAILSF_VALUE
End Sub

Public Property Get MixerDestinationVolume( _
    ByVal deviceid As Long, _
    ByVal destination As Long _
) As volume_stereo

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim udtVol  As volume_stereo
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_DESTINATION

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_VOLUME, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = udtML.cChannels
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(udtVol)
    End With

    mixerGetControlDetails deviceid, udtMCL, MIXER_GETCONTROLDETAILSF_VALUE

    MixerDestinationVolume = udtVol
End Property

Public Property Get MixerConnectionVolume( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal connection As Long _
) As volume_stereo

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim udtVol  As volume_stereo
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination
    udtML.dwSource = connection

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_SOURCE

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_VOLUME, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = udtML.cChannels
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(udtVol)
    End With

    mixerGetControlDetails deviceid, _
                           udtMCL, _
                           MIXER_GETCONTROLDETAILSF_VALUE

    MixerConnectionVolume = udtVol
End Property

Public Sub MixerSetDestinationMute( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal Value As Boolean _
)

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim udtBool As MIXERCONTROLDETAILS_BOOLEAN
    Dim CtrlID  As Long
    Dim rc      As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    udtBool.fValue = Abs(Value)

    rc = mixerGetLineInfo(deviceid, udtML, MIXER_GETLINEINFOF_DESTINATION)

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_MUTE, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = 1
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(udtBool)
    End With

    rc = mixerSetControlDetails(deviceid, udtMCL, MIXER_GETCONTROLDETAILSF_VALUE)
End Sub

Public Sub MixerSetConnectionMute( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal connection As Long, _
    ByVal Value As Boolean _
)

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim udtBool As MIXERCONTROLDETAILS_BOOLEAN
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination
    udtML.dwSource = connection

    udtBool.fValue = Abs(Value)

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_SOURCE

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_MUTE, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = 1
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(udtBool)
    End With

    mixerSetControlDetails deviceid, udtMCL, MIXER_GETCONTROLDETAILSF_VALUE
End Sub

Public Property Get MixerDestinationMute( _
    ByVal deviceid As Long, _
    ByVal destination As Long _
) As Boolean

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim udtBool As MIXERCONTROLDETAILS_BOOLEAN
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_DESTINATION

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_MUTE, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = udtML.cChannels
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(udtBool)
    End With

    mixerGetControlDetails deviceid, udtMCL, MIXER_GETCONTROLDETAILSF_VALUE

    MixerDestinationMute = CBool(udtBool.fValue)
End Property

Public Property Get MixerConnectionMute( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal connection As Long _
) As Boolean

    Dim udtML   As MIXERLINE
    Dim udtMCL  As MIXERCONTROLDETAILS
    Dim udtBool As MIXERCONTROLDETAILS_BOOLEAN
    Dim CtrlID  As Long

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination
    udtML.dwSource = connection

    mixerGetLineInfo deviceid, udtML, MIXER_GETLINEINFOF_SOURCE

    CtrlID = MixerGetControlID(deviceid, _
                               udtML.dwComponentType, _
                               MIXERCONTROL_CONTROLTYPE_MUTE, _
                               udtML.dwLineID)

    With udtMCL
        .cbDetails = 4
        .cbStruct = Len(udtMCL)
        .cChannels = udtML.cChannels
        .dwControlID = CtrlID
        .item = 0
        .paDetails = VarPtr(udtBool)
    End With

    mixerGetControlDetails deviceid, udtMCL, MIXER_GETCONTROLDETAILSF_VALUE

    MixerConnectionMute = CBool(udtBool.fValue)
End Property

Public Property Get MixerDestinationChannels( _
    ByVal deviceid As Long, _
    ByVal destination As Long _
) As Integer

    Dim udtML   As MIXERLINE

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, _
                     udtML, _
                     MIXER_GETLINEINFOF_DESTINATION

    MixerDestinationChannels = udtML.cChannels
End Property

Public Property Get MixerConnectionChannels( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal connection As Long _
) As Integer

    Dim udtML   As MIXERLINE

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination
    udtML.dwSource = connection

    mixerGetLineInfo deviceid, _
                     udtML, _
                     MIXER_GETLINEINFOF_SOURCE

    MixerConnectionChannels = udtML.cChannels
End Property

Public Property Get MixerConnectionName( _
    ByVal deviceid As Long, _
    ByVal destination As Long, _
    ByVal connection As Long _
) As String

    Dim udtML   As MIXERLINE

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination
    udtML.dwSource = connection

    mixerGetLineInfo deviceid, _
                     udtML, _
                     MIXER_GETLINEINFOF_SOURCE

    MixerConnectionName = udtML.szName
End Property

Public Property Get MixerDestinationConnections( _
    ByVal deviceid As Long, _
    ByVal destination As Long _
) As Long

    Dim udtML   As MIXERLINE

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, _
                     udtML, _
                     MIXER_GETLINEINFOF_DESTINATION

    MixerDestinationConnections = udtML.cConnections
End Property

Public Property Get MixerDestinationType( _
    ByVal deviceid As Long, _
    ByVal destination As Long _
) As Long

    Dim udtML   As MIXERLINE

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, _
                     udtML, _
                     MIXER_GETLINEINFOF_DESTINATION

    MixerDestinationType = udtML.dwComponentType
End Property

Public Property Get MixerDestinationName( _
    ByVal deviceid As Long, _
    ByVal destination As Long _
) As String

    Dim udtML   As MIXERLINE

    udtML.cbStruct = Len(udtML)
    udtML.dwDestination = destination

    mixerGetLineInfo deviceid, _
                     udtML, _
                     MIXER_GETLINEINFOF_DESTINATION

    MixerDestinationName = udtML.szName
End Property

Public Property Get MixerDestinations( _
    ByVal deviceid As Long _
) As Long

    Dim udtCaps As MIXERCAPS

    mixerGetDevCaps deviceid, udtCaps, Len(udtCaps)

    MixerDestinations = udtCaps.cDestinations
End Property

Public Function MixerGetControlID( _
    ByVal deviceid As Long, _
    ByVal ComponentType As Long, _
    ByVal ControlType As Long, _
    ByVal LineID As Long _
) As Long

    Dim hMem     As Long
    Dim MC       As MIXERCONTROL
    Dim MxrLine  As MIXERLINE
    Dim MLC      As MIXERLINECONTROLS

    MxrLine.cbStruct = Len(MxrLine)
    MxrLine.dwComponentType = ComponentType

    If mixerGetLineInfo(deviceid, _
                        MxrLine, _
                        MIXER_GETLINEINFOF_COMPONENTTYPE) = 0 Then

        MLC.cbStruct = Len(MLC)
        MLC.dwLineID = LineID
        MLC.dwControl = ControlType
        MLC.cControls = 1
        MLC.cbmxctrl = Len(MC)

        hMem = GlobalAlloc(&H40, Len(MC))
        MLC.pamxctrl = GlobalLock(hMem)

        MC.cbStruct = Len(MC)

        If mixerGetLineControls(deviceid, _
                                MLC, _
                                MIXER_GETLINECONTROLSF_ONEBYTYPE) = 0 Then

            CopyStructFromPtr MC, MLC.pamxctrl, Len(MC)
            MixerGetControlID = MC.dwControlID
        End If

        GlobalUnlock hMem
        GlobalFree hMem
    End If
End Function
